using System;
using System.Data;
using System.Collections;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using SD.LLBLGen.Pro.ORMSupportClasses;

using GridViewExample.biz;
using GridViewExample.biz.EntityClasses;
using GridViewExample.biz.CollectionClasses;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //this validation will ensure the loading of the records in the tables happens only when loading the page and
        //not when doing any postback
        if (!IsPostBack)
        {
            //this is propetary code you don't need to understand
            RecordsCollection colRecords = new RecordsCollection();
            colRecords.GetMulti(null);
            //the datasource is specified in the gridview
            GridView1.DataSource = colRecords;
            //calling the databind method
            GridView1.DataBind();
            //calling the procedure that will add the checkbox functionality
            pvCompleteGridView();
        }
    }

    /// <summary>
    /// this procedure adds the javascript methods to the header and the row checkboxes in order for them to work 
    /// properly without using postbacks
    /// </summary>
    protected void pvCompleteGridView()
    {
        if (GridView1.Rows.Count > 0)
        {
            //array list that will contain the id's of all the checkboxes in the gridview including the header checkbox
            ArrayList ArrayValues = new ArrayList();
            CheckBox cbHeader = new CheckBox();
            //finding the header checkbox
            cbHeader = (CheckBox)GridView1.HeaderRow.FindControl("cbHeader");
            //adding the ID of the header box to the array list
            ArrayValues.Add(String.Concat("'", cbHeader.ClientID, "'"));
            //adding the javascript method to change the sate of all row checkboxes to the header checkbox
            cbHeader.Attributes.Add("onClick", "ChangeAllCheckBoxStates(this.checked);");
            int i = 0;
            while (i < GridView1.Rows.Count)
            {
                CheckBox cbItem = new CheckBox();
                //finding the checkbox in every row
                cbItem = (CheckBox)GridView1.Rows[i].FindControl("cbItem");
                //adding the ID of every row checkbox to the array list
                ArrayValues.Add(String.Concat("'", cbItem.ClientID, "'"));
                //adding the javascript method to verify the state of all the checkboxes in the row chexbox
                cbItem.Attributes.Add("onClick", "ChangeHeaderState();");
                i++;
            }
            //transforming the arraylist into a strings array
            string[] values = (string[])ArrayValues.ToArray(typeof(string));
            //declaring the javascript array variable in the server label
            CheckBoxIDsArray.Text = "<script type=\"text/javascript\">" + Environment.NewLine + "<!--" + Environment.NewLine + String.Concat("var CheckBoxIDs = new Array(", String.Join(",", values), ");") + Environment.NewLine + "// -->" + Environment.NewLine + "</script>";
        }
    }

    protected void GridView1_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        //switch case statement that will differentiate between image button columns
        switch (e.CommandName)
        {
                //when clicking the show button, the description of the row where the button was clicked is displayed in the descriptions div
                case ("ibtnShow"):
                    divDescriptions.InnerHtml = "Description: " + GridView1.Rows[Convert.ToInt32(e.CommandArgument)].Cells[4].Text;                
                break;
        }
    }

    protected void btnShowMultiple_Click(object sender, EventArgs e)
    {
        int i = 0;
        divDescriptions.InnerHtml = "";
        while (i < GridView1.Rows.Count)
        {
            //finding the checkbox in every row
            CheckBox cbCell = (CheckBox)GridView1.Rows[i].FindControl("cbItem");
            //verifying if the checkbox is checked
            if (cbCell.Checked)
            {
                //if the checkbox is checked, the description of that row is appended to the descriptions div
                divDescriptions.InnerHtml += "Description: " + GridView1.Rows[i].Cells[4].Text + "<br />";                
            }
            i++;
        }
    }
}
